<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="年份" prop="year">
        <el-select
          v-model="queryParams.year"
          placeholder="请选择年份"
          clearable
        >
          <el-option
            v-for="year in yearList"
            :key="year"
            :label="year"
            :value="year"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="州市" prop="cityName">


        <el-select v-model="queryParams.cityCode" placeholder="请选择州市" >
          <el-option
            v-for="region in regionOptions"
            :key="region.cityShortName"
            :label="region.cityShortName"
            :value="region.code"
          />
        </el-select>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置/刷新</el-button>
      </el-form-item>
    </el-form>
    <!--
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['dimp:dMarketsubDataInfo:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    -->

    <el-table v-loading="loading" :data="dMarketsubDataInfoList" @selection-change="handleSelectionChange" :header-cell-style="{background:'#2a8eed',color:'#fafcfe',}" border>
      <el-table-column type="selection" width="55" align="center" v-if="false" />
      <el-table-column label="id" align="center" prop="id" v-if="false"/>
      <el-table-column label="年份" align="center" prop="year" />
      <el-table-column label="州市" align="center" prop="cityName" />
      <el-table-column label="主体数（万户）" align="center" prop="marketsubTotal" />
      <!--
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="状态" align="center" prop="status" />
      -->
      <!-- <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            type="primary"
            size="small"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['dimp:dHighValueInfo:edit']"
          >调整</el-button>
        </template>
      </el-table-column> -->
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改市场主体数据导入对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="城市代码" prop="cityCode">
          <el-input v-model="form.cityCode" placeholder="请输入城市代码" />
        </el-form-item>
        <el-form-item label="城市名称" prop="cityName">
          <el-input v-model="form.cityName" placeholder="请输入城市名称" />
        </el-form-item>
        <el-form-item label="总人口" prop="marketsubTotal">
          <el-input v-model="form.marketsubTotal" placeholder="请输入总人口" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
        <el-form-item label="删除标识  " prop="delFlag">
          <el-input v-model="form.delFlag" placeholder="请输入删除标识  " />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listDMarketsubDataInfo, getDMarketsubDataInfo, delDMarketsubDataInfo, addDMarketsubDataInfo, updateDMarketsubDataInfo } from "@/api/dimp/dMarketsubDataInfo";
import {listUrPatentValid, getHeaderList, getRegionList} from "@/api/system/urPatentValid";
import {
  getYearList
} from "@/api/report/rzlViewStatisticsInfo";
export default {
  name: "DMarketsubDataInfo",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      regionOptions: [],
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 市场主体数据导入表格数据
      dMarketsubDataInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      yearList: [],
      // 查询参数
      queryParams: {
        year:'2022',
          pageNum: 1,
          pageSize: 10,
        cityCode: null,
        cityName: null,
        dataYear: null,
        marketsubTotal: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getYear();
    this.getRegion();
    this.getList();
  },
  methods: {
    /** 获取省市列表 */
    getRegion() {
      let params = {};
      getRegionList(params).then(response => {
        this.regionOptions = response.data;
      });
    },
    /** 获取查询年份列表 */
    getYear() {
      getYearList().then((response) => {
        //this.hasYearList=response.data;
        this.yearList = response.data;
      });
    },
    /** 查询市场主体数据导入列表 */
    getList() {
      this.loading = true;
      listDMarketsubDataInfo(this.queryParams).then(response => {
        this.dMarketsubDataInfoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        cityCode: null,
        cityName: null,
        dataYear: null,
        marketsubTotal: null,
        remark: null,
        delFlag: null,
        status: 0,
        createTime: null,
        createBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加市场主体数据导入";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getDMarketsubDataInfo(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改市场主体数据导入";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateDMarketsubDataInfo(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addDMarketsubDataInfo(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除市场主体数据导入编号为"' + ids + '"的数据项？').then(function() {
        return delDMarketsubDataInfo(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('dimp/dMarketsubDataInfo/export', {
        ...this.queryParams
      }, `dMarketsubDataInfo_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
